
//Net Dance Server
//Server thread for networked performance system One Bit Net Dance
//Andreja Andric
//2018

import java.net.*;
import java.io.*;
import java.util.*;

public class NetDanceServerThread extends Thread {
    private Socket socket = null;
    public String Name;
    NetDanceServer Mom;
    private int index;
    private String Melody;
    private String Input0;
    private boolean NewState;

    public void SetNewState() { NewState = true; }
    public void DecrementIndex() { index--; }
    public String GetName() { return Name; }
    public String GetMelody() { return Melody; }
    public int GetIndex() { return index; }
    public String GetInput0() { return Input0; }
    public void SetInput0(String s) { Input0=s; }
  
    public NetDanceServerThread(Socket socket, NetDanceServer m, int i )
    {
        super("NetDanceServerThread");
	this.socket = socket;
        Mom = m;
        index = i;
        Melody = "0 0";
        Input0 = " ";
        NewState = true;
    }

    int findParam(String p)
    {
       for(int i=0;i<5;i++)
          if(p.startsWith(Mom.OverallParams[i]))
             return i;
       return -1;
    }

    String RemoveParamsFromInput(String input)
    {
       int paramsEnd = input.lastIndexOf('/');
       if(paramsEnd>=0)
       {
          do
          { paramsEnd++; }
          while(input.charAt(paramsEnd)>='0'&&input.charAt(paramsEnd)<='9');
          input = input.substring(paramsEnd);
       }
       return input;
    }

    public void run() {

	try {
	    PrintWriter out = new PrintWriter(socket.getOutputStream(), true);
	    BufferedReader in = new BufferedReader(
				    new InputStreamReader(
				    socket.getInputStream()));

            String inputLine, outputLine;
            Name = in.readLine();
            System.out.println("New client: "+Name);
            out.println(index);
            out.println("Welcome");
	    while (true)
            {
                int i;
                try
                {
                   inputLine = in.readLine();
                }
                catch(java.net.SocketException e)
                {
                   System.out.println("Connection lost with "+Name);
                   break;
                }
                if (inputLine.equals("get"))
                {
                   if(!NewState)
                      out.println("N");
                   else
                   {
                      Mom.lockClientList();
                      try
                      {
                         out.println("more lines");
                         for(i=0;i<Mom.OverallParams.length;i++)
                         {
                            out.println(Mom.OverallParamValues[i]);
                         }
                         out.println(Mom.GetMelody());
                         out.println(Mom.clientList.size());
                         for(i=0;i<Mom.clientList.size();i++)
                         {
                            NetDanceServerThread ndnst = (NetDanceServerThread)Mom.clientList.elementAt(i);
                            out.println(ndnst.GetName());
                            out.println(ndnst.GetIndex());
                            if(Mom.clientList.elementAt(i).index==index)
                            {
                               int j;
                               for(j=0;j<Mom.OverallParams.length-1;j++)
                                  out.println(Mom.OverallParams[j] + ": " + Mom.OverallParamValues[j]);
                               out.print(Mom.OverallParams[j] + ": " + Mom.OverallParamValues[j]);
                            }
                            out.println(Mom.clientList.elementAt(i).GetInput0());
                            out.println("end part");
                         }
                         out.println("end lines");
                      }
                      finally
                      {
                         Mom.unlockClientList();
                      }
                      NewState = false;
                   }
                }
                else
                if (inputLine.equals("put"))
                {
                   for(int j=0;j<Mom.clientList.size();j++)
                      Mom.clientList.elementAt(j).SetNewState();
                   inputLine = in.readLine();
                   int iRes = Mom.UpdateParams(inputLine);
                   if(iRes!=0)
                      out.println("Wrong number of arguments, should be at least 6.");
                   inputLine = in.readLine();
                   Melody = inputLine;
                   Mom.UpdateMelody();
                   StringBuilder sb = new StringBuilder();
                   do
                   {
                      inputLine = in.readLine();
                      if(inputLine.equals("end lines"))
                         break;
                      sb.append(inputLine);
                      sb.append(System.lineSeparator());
                   } while(true);
                   Input0 = RemoveParamsFromInput(sb.toString());
                   out.println("Ok.");
                }
                else
                if (inputLine.equals("bye"))
                   break;
                else
                   out.println("Error! Type a command (get, put, bye, melody or param change). You entered: "+inputLine);
	    }
            out.println("bye");
            Mom.remove(index);
            Mom.UpdateMelody();
            out.close();
	    in.close();
            Mom.StopServerIfNoClients();
	} catch (IOException e) {
	    e.printStackTrace();
	}
    }
}
